<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SingleVaultResponse StructType
 * @subpackage Structs
 */
class SingleVaultResponse extends AbstractStructBase
{
    /**
     * The CardVaultResponse
     * @var \StructType\CardVaultResponseType
     */
    public $CardVaultResponse;
    /**
     * The WalletVaultResponse
     * @var \StructType\WalletVaultResponseType
     */
    public $WalletVaultResponse;
    /**
     * The LookUpVaultResponse
     * @var \StructType\LookUpVaultResponseType
     */
    public $LookUpVaultResponse;
    /**
     * The DeleteVaultResponse
     * @var \StructType\DeleteVaultResponseType
     */
    public $DeleteVaultResponse;
    /**
     * Constructor method for SingleVaultResponse
     * @uses SingleVaultResponse::setCardVaultResponse()
     * @uses SingleVaultResponse::setWalletVaultResponse()
     * @uses SingleVaultResponse::setLookUpVaultResponse()
     * @uses SingleVaultResponse::setDeleteVaultResponse()
     * @param \StructType\CardVaultResponseType $cardVaultResponse
     * @param \StructType\WalletVaultResponseType $walletVaultResponse
     * @param \StructType\LookUpVaultResponseType $lookUpVaultResponse
     * @param \StructType\DeleteVaultResponseType $deleteVaultResponse
     */
    public function __construct(\StructType\CardVaultResponseType $cardVaultResponse = null, \StructType\WalletVaultResponseType $walletVaultResponse = null, \StructType\LookUpVaultResponseType $lookUpVaultResponse = null, \StructType\DeleteVaultResponseType $deleteVaultResponse = null)
    {
        $this
            ->setCardVaultResponse($cardVaultResponse)
            ->setWalletVaultResponse($walletVaultResponse)
            ->setLookUpVaultResponse($lookUpVaultResponse)
            ->setDeleteVaultResponse($deleteVaultResponse);
    }
    /**
     * Get CardVaultResponse value
     * @return \StructType\CardVaultResponseType|null
     */
    public function getCardVaultResponse()
    {
        return $this->CardVaultResponse;
    }
    /**
     * Set CardVaultResponse value
     * @param \StructType\CardVaultResponseType $cardVaultResponse
     * @return \StructType\SingleVaultResponse
     */
    public function setCardVaultResponse(\StructType\CardVaultResponseType $cardVaultResponse = null)
    {
        $this->CardVaultResponse = $cardVaultResponse;
        return $this;
    }
    /**
     * Get WalletVaultResponse value
     * @return \StructType\WalletVaultResponseType|null
     */
    public function getWalletVaultResponse()
    {
        return $this->WalletVaultResponse;
    }
    /**
     * Set WalletVaultResponse value
     * @param \StructType\WalletVaultResponseType $walletVaultResponse
     * @return \StructType\SingleVaultResponse
     */
    public function setWalletVaultResponse(\StructType\WalletVaultResponseType $walletVaultResponse = null)
    {
        $this->WalletVaultResponse = $walletVaultResponse;
        return $this;
    }
    /**
     * Get LookUpVaultResponse value
     * @return \StructType\LookUpVaultResponseType|null
     */
    public function getLookUpVaultResponse()
    {
        return $this->LookUpVaultResponse;
    }
    /**
     * Set LookUpVaultResponse value
     * @param \StructType\LookUpVaultResponseType $lookUpVaultResponse
     * @return \StructType\SingleVaultResponse
     */
    public function setLookUpVaultResponse(\StructType\LookUpVaultResponseType $lookUpVaultResponse = null)
    {
        $this->LookUpVaultResponse = $lookUpVaultResponse;
        return $this;
    }
    /**
     * Get DeleteVaultResponse value
     * @return \StructType\DeleteVaultResponseType|null
     */
    public function getDeleteVaultResponse()
    {
        return $this->DeleteVaultResponse;
    }
    /**
     * Set DeleteVaultResponse value
     * @param \StructType\DeleteVaultResponseType $deleteVaultResponse
     * @return \StructType\SingleVaultResponse
     */
    public function setDeleteVaultResponse(\StructType\DeleteVaultResponseType $deleteVaultResponse = null)
    {
        $this->DeleteVaultResponse = $deleteVaultResponse;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SingleVaultResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
